unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.Classes, System.SysUtils, System.StrUtils, System.Types, System.Math, System.UITypes, Data.DB,
  Data.Win.ADODB, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Controls, Vcl.Menus, Vcl.Forms, Vcl.Dialogs, Vcl.Buttons, Vcl.ExtDlgs, Vcl.Graphics,
  Vcl.Imaging.jpeg, VclTee.TeEngine, VclTee.Series, VclTee.TeeComma, VclTee.TeeGDIPlus, VclTee.TeeProcs, VclTee.Chart, VclTee.TeeLisB,
  VclTee.TeeTools, VclTee.TeeArrowTool, VclTee.TeeEdit, VclTee.TeCanvas, VclTee.TeePenDlg, VclTee.TeeEdiGrad, VclTee.EditChar,
  VclTee.TeeCustomLegendTool, VclTee.TeeSubChart, VclTee.TeeJPEG, VclTee.TeeGIF, VclTee.TeePNG,
{$IFNDEF CPUX64}
  VclTee.TeePCX,
{$ENDIF}
  VclTee.TeePDFCanvas, VclTee.TeeSVGCanvas, VclTee.TeePSCanvas, VclTee.TeeVMLCanvas, VclTee.TeeHTML5Canvas, VclTee.TeExport, VclTee.TeeEdiGene,
  VclTee.TeePrevi,
  VclTee.TeePreviewPanel;

const
  mySeriesColor: array [0 .. 2] of TColor = (clBlue, clRed, clGreen);

type
  TForm1 = class(TForm)
    Button3: TButton;
    ChartListBox1: TChartListBox;
    CheckBox1: TCheckBox;
    TheChart: TChart;
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    SubChartTool: TSubChartTool;
    SubChart: TChart;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  UAxis_Iso, UPlot_Func;

procedure TForm1.FormCreate(Sender: TObject);
begin
  KeyPreview := true;

  TheChart.SeriesList.Clear;
  Setup_Chart_Axes(TheChart);

  if SubChartTool = nil then
    begin
      SubChartTool := TSubChartTool.Create(Self);
      TheChart.Tools.Add(SubChartTool);
    end;
  SubChart := SubChartTool.Charts.AddChart('SubChart');
  SubChart.Width := TheChart.Width div 2;
  SubChart.Height := TheChart.Height div 2;
  SubChart.SeriesList.Clear;
  Setup_Chart_Axes(SubChart);

  with ChartListBox1 do
    begin
      ChartListBox1.Chart := TheChart;
      AllowDeleteSeries := false;
      AllowAddSeries := false;
    end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  i: integer;
begin
  { The curves on TheChart and SubChart correspond one to one. Series Groups are used to synchronously show/hide a curve or change its properties. }
  TheChartSeriesGroup := TheChart.SeriesList.AddGroup('TheChart SeriesGroup');
  TheChart.Foot.Text.Text := 'TheChart & SubChart';
  SubChartSeriesGroup := TheChart.SeriesList.AddGroup('SubChart SeriesGroup');
  SubChart.Foot.Visible := false;

  TheChart_Axes(TheChart);
  SubChart_Axes(SubChart);

  for i := 0 to 1 do
    begin
      Add_LineSeries(TheChart, TheChartSeriesGroup, true, 'TheChart Series ' + IntToStr(i + 1), mySeriesColor[i], true); { Add Series }
      LineSeries_Data(TheChart, true, i); { Assign Series's data }
      Add_LineSeries(SubChart, SubChartSeriesGroup, false, 'SubChart Series ' + IntToStr(i + 1), mySeriesColor[i], false);
      LineSeries_Data(SubChart, false, i);
    end;

  with TheChart.SeriesList.Groups do
    begin
      for i := 0 to Count - 1 do
        Items[i].Show;
    end;
  ChartListBox1.SeriesGroup := TheChartSeriesGroup;
  if ChartListBox1.SeriesGroup.Series.Count > 0 then
    ChartListBox1.SelectedSeries := ChartListBox1.SeriesGroup.Series.First
  else
    ChartListBox1.SelectedSeries := nil;
  TheChart.Zoom.History := true;
  TheChart.Draw;

  CheckBox1.Checked := true;
  CheckBox1Click(Self);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  { Make TheChart to be isometric axis }
  TheChart_IsoAxis(TheChart, true, 0, 2);

  if SubChart <> nil then
    begin
      SubChart := TSubChartTool(SubChartTool).Charts[0].Chart;
      { Make SubChart to be isometric axis, and its Axis Scales of horizontal and vertical Axes are the same with TheChart's Axis Scales, respectively. }
      SubChart_SizePostion(TheChart, SubChart);
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

end.
